routes/web.php
<?php

use App\Http\Controllers\Contracts\ContractController;
use App\Http\Controllers\Estimates\EstimateController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\Roles\RoleController;
use App\Http\Controllers\Services\ServiceController;
use App\Http\Controllers\SubTours\SubTourController;
use App\Http\Controllers\Tours\TourController;
use App\Http\Controllers\Users\UserController;
use App\Http\Controllers\Commissions\CommissionController;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return redirect('login');
});

Auth::routes();

Route::get('/home', [HomeController::class, 'index'])
    ->name('home')
    ->middleware('auth');

Route::group(['middleware' => 'auth'], function() {
    Route::name('tours.')->prefix('tours')->group(function () {
        Route::get('/', [TourController::class, 'index'])
            ->name('index')
            ->middleware('has_permission:tour-list');
        Route::get('/create', [TourController::class, 'create'])
            ->name('create')
            ->middleware('has_permission:tour-create');
        Route::post('/', [TourController::class, 'store'])
            ->name('store')
            ->middleware('has_permission:tour-create');
        Route::get('/edit/{id}', [TourController::class, 'edit'])
            ->name('edit')
            ->middleware('has_permission:tour-edit');
        Route::put('/{id}', [TourController::class, 'update'])
            ->name('update')
            ->middleware('has_permission:tour-edit');
        Route::delete('/{id}', [TourController::class, 'destroy'])
            ->name('destroy')
            ->middleware('has_permission:tour-delete');
        Route::get('/show/{id}', [TourController::class, 'show'])
            ->name('show')
            ->middleware('has_permission:tour-list');
        Route::get('/search', [TourController::class, 'search'])
            ->name('search');
    });
    Route::name('users.')->prefix('users')->group(function () {
        Route::get('/', [UserController::class, 'index'])
            ->name('index')
            ->middleware('has_permission:user-list');
        Route::get('/create', [UserController::class, 'create'])
            ->name('create')
            ->middleware('has_permission:user-create');
        Route::post('/', [UserController::class, 'store'])
            ->name('store')
            ->middleware('has_permission:user-create');
        Route::get('/edit/{id}', [UserController::class, 'edit'])
            ->name('edit')
            ->middleware('has_permission:user-edit');
        Route::put('/{id}', [UserController::class, 'update'])
            ->name('update')
            ->middleware('has_permission:user-edit');
        Route::delete('/{id}', [UserController::class, 'destroy'])
            ->name('destroy')
            ->middleware('has_permission:user-delete');
        Route::get('/show/{id}', [UserController::class, 'show'])
            ->name('show')
            ->middleware('has_permission:user-list');
        Route::get('/search', [UserController::class, 'search'])
            ->name('search');
    });
    Route::name('services.')->prefix('services')->group(function () {
        Route::get('/', [ServiceController::class, 'index'])
            ->name('index')
            ->middleware('has_permission:service-list');
        Route::get('/create', [ServiceController::class, 'create'])
            ->name('create')
            ->middleware('has_permission:service-create');
        Route::post('/', [ServiceController::class, 'store'])
            ->name('store')
            ->middleware('has_permission:service-create');
        Route::get('/edit/{id}', [ServiceController::class, 'edit'])
            ->name('edit')
            ->middleware('has_permission:service-edit');
        Route::put('/{id}', [ServiceController::class, 'update'])
            ->name('update')
            ->middleware('has_permission:service-edit');
        Route::delete('/{id}', [ServiceController::class, 'destroy'])
            ->name('destroy')
            ->middleware('has_permission:service-delete');
        Route::get('/show/{id}', [ServiceController::class, 'show'])
            ->name('show')
            ->middleware('has_permission:service-list');
    });
    Route::name('roles.')->prefix('roles')->group(function () {
        Route::get('/', [RoleController::class, 'index'])
            ->name('index')
            ->middleware('has_permission:role-list');
        Route::get('/create', [RoleController::class, 'create'])
            ->name('create')
            ->middleware('has_permission:role-create');
        Route::post('/', [RoleController::class, 'store'])
            ->name('store')
            ->middleware('has_permission:role-create');
        Route::get('/edit/{id}', [RoleController::class, 'edit'])
            ->name('edit')
            ->middleware('has_permission:role-edit');
        Route::put('/{id}', [RoleController::class, 'update'])
            ->name('update')
            ->middleware('has_permission:role-edit');
        Route::delete('/{id}', [RoleController::class, 'destroy'])
            ->name('destroy')
            ->middleware('has_permission:role-delete');
        Route::get('/show/{id}', [RoleController::class, 'show'])
            ->name('show')
            ->middleware('has_permission:role-list');
        Route::get('/search', [RoleController::class, 'search'])
            ->name('search');
    });
    Route::name('subTours.')->prefix('subTours')->group(function () {
        Route::get('/', [SubTourController::class, 'index'])
            ->name('index');
        Route::get('/create', [SubTourController::class, 'create'])
            ->name('create');
        Route::post('/', [SubTourController::class, 'store'])
            ->name('store');
        Route::get('/edit/{id}', [SubTourController::class, 'edit'])
            ->name('edit');
        Route::put('/{id}', [SubTourController::class, 'update'])
            ->name('update');
        Route::delete('/{id}', [SubTourController::class, 'destroy'])
            ->name('destroy');
        Route::get('/show/{id}', [SubTourController::class, 'show'])
            ->name('show');
        Route::get('/search', [SubTourController::class, 'search'])
            ->name('search');
    });

    Route::name('estimates.')->prefix('estimates')->group(function () {
        Route::get('subTour/{subTourId}', [EstimateController::class, 'index'])
            ->name('index');
        Route::get('/create', [EstimateController::class, 'create'])
            ->name('create');
        Route::post('/', [EstimateController::class, 'store'])
            ->name('store');
        Route::get('/edit/{id}', [EstimateController::class, 'edit'])
            ->name('edit');
        Route::put('/{id}', [EstimateController::class, 'update'])
            ->name('update');
        Route::delete('/{id}', [EstimateController::class, 'destroy'])
            ->name('destroy');
        Route::get('/show/{id}', [EstimateController::class, 'show'])
            ->name('show');
        Route::get('/search', [EstimateController::class, 'search'])
            ->name('search');
        Route::get('/export/{id}', [EstimateController::class, "export"])
            ->name("export");
    });

    Route::name('contracts.')->prefix('contracts')->group(function () {
        Route::get('subTour/{subTourId}', [ContractController::class, 'index'])
            ->name('index')
            ->middleware('has_permission:contract-list');
        Route::get('subTour/{subTourId}/create', [ContractController::class, 'create'])
            ->name('create')
            ->middleware('has_permission:contract-create');
        Route::post('/', [ContractController::class, 'store'])
            ->name('store');
        Route::get('/edit/{id}', [ContractController::class, 'edit'])
            ->name('edit')
            ->middleware('has_permission:contract-edit');
        Route::put('/{id}', [ContractController::class, 'update'])
            ->name('update')
            ->middleware('has_permission:contract-edit');
        Route::delete('/{id}', [ContractController::class, 'destroy'])
            ->name('destroy')
            ->middleware('has_permission:contract-delete');
        Route::get('/show/{id}', [ContractController::class, 'show'])
            ->name('show')
            ->middleware('has_permission:contract-list');
        Route::get('/search', [ContractController::class, 'search'])
            ->name('search');
        Route::get('/createContract/{id}', [ContractController::class, "createContractFile"])
            ->name("createContractFile");
        Route::get('/contract/{contractId}/history', [ContractController::class, "history"])
            ->name("history");
    });
    Route::name('commissions.')->prefix('commissions')->group(function () {
        Route::get('contract/{contractId}', [CommissionController::class, 'index'])
            ->name('index')
            ->middleware('has_permission:contract-list');
        Route::get('contract/{contractId}/create', [CommissionController::class, 'create'])
            ->name('create');
        Route::post('/', [CommissionController::class, 'store'])
            ->name('store');
        Route::get('/edit/{id}', [CommissionController::class, 'edit'])
            ->name('edit');
        Route::put('/{id}', [CommissionController::class, 'update'])
            ->name('update');
        Route::delete('/{id}', [CommissionController::class, 'destroy'])
            ->name('destroy');

app/Models/User.php
<?php

namespace App\Models;

use App\Http\Traits\CheckHasPermissionTrait;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Illuminate\Support\Facades\Hash;
use Laravel\Sanctum\HasApiTokens;
use Spatie\Permission\Traits\HasRoles;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;
    use HasRoles;
    use CheckHasPermissionTrait;

    /**
     * The attributes that are mass assignable.
     *
     * @var string[]
     */

    protected $fillable = [
        'user_code',
        'full_name',
        'email',
        'phone',
        'password',
        'citizens_id',
        'address',
        'dob',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    public function setPasswordAttribute($value): string
    {
        return $this->attributes['password'] = Hash::make($value);
    }

    public function search($key)
    {
        return User::where('email', 'LIKE', '%' . $key. '%')->orWhere('full_name', 'LIKE', '%' . $key. '%')->latest('id')->paginate(5);
    }

    public function contracts()
    {
        return $this->hasMany(Contract::class, 'create_by', 'id');
    }

    public function commission()
    {
        return $this->hasMany(Commission::class);
    }
}

app/Http/Controllers/Users/UserController.php
<?php

namespace App\Http\Controllers\Users;

use App\Http\Controllers\Controller;
use App\Models\User;
use App\Services\RoleService;
use App\Services\UserService;
use Illuminate\Http\Request;

class UserController extends Controller
{
    protected $userService;
    protected $roleService;
    protected $user;

    public function __construct(UserService $userService, RoleService $roleService, User $user)
    {
        $this->userService = $userService;
        $this->roleService = $roleService;
        $this->user = $user;
    }

    public function index()
    {
        $users = $this->userService->index();
        return view('admin.users.index', compact('users'));
    }

    public function create()
    {
        $roles = $this->roleService->getAllRole();
        return view('admin.users.create', compact('roles'));
    }

    public function store(Request $request)
    {
        $this->userService->create($request);
        $roles = $this->roleService->getAllRole();
        return redirect()->route('users.index', compact('roles'));
    }

    public function show(int $id)
    {
        $user = $this->userService->show($id);
        return view('admin.users.show', compact('user'));
    }

    public function edit($id)
    {
        $user = $this->userService->findById($id);
        $roles = $this->roleService->getAllRole();
        return view('admin.users.edit', compact('user', 'roles'));
    }

    public function update(Request $request, int $id)
    {
        $this->userService->update($request, $id);
        return redirect()->route('users.index');
    }

    public function destroy($id)
    {
        $this->userService->destroy($id);
        return redirect()->route('users.index');
    }

    public function search(Request $request)
    {
        $key = $request->input('key') ?? '';
        $result = $this->user->search($key);
        return view('admin.users.index', ['users' => $result]);
    }
}

resources/views/admin/users/create.blade.php
@extends('admin.layouts.app')

@section('title')
    <title>Create User</title>
@endsection

@section('content')
    <div id="layoutSidenav_content">
        <main>
            <div class="container-fluid px-4">
                <h1 class="mt-4">Create User</h1>
                <ol class="breadcrumb mb-4">
                    <a class="breadcrumb-item active" href="{{ url()->previous() }}">Back>></a>
                </ol>
                <div class="container">
                    <div class="row justify-content-center">
                        <form action="{{route('users.store')}}" method="POST" enctype="multipart/form-data">
                            @csrf
                            <div class="mb-3">
                                <div class="form-group">
                                    <label class="form-label">User Code</label>
                                    <input name="user_code" type="text" class="form-control"
                                           placeholder="User Code...">
                                </div>
                            </div>
                            <div class="mb-3">
                                <div class="form-group">
                                    <label class="form-label">Full Name</label>
                                    <input name="full_name" type="text" class="form-control"
                                           placeholder="Full Name...">
                                </div>
                            </div>
                            <div class="mb-3">
                                <div class="form-group">
                                    <label class="form-label">Email</label>
                                    <input name="email" type="text" class="form-control"
                                           placeholder="Email...">
                                </div>
                            </div>
                            <div class="mb-3">
                                <div class="form-group">
                                    <label class="form-label">Phone</label>
                                    <input name="phone" type="text" class="form-control"
                                           placeholder="Phone...">
                                </div>
                            </div>
                            <div class="mb-3">
                                <div class="form-group">
                                    <label class="form-label">Password</label>
                                    <input name="password" type="password" class="form-control"
                                           placeholder="Password...">
                                </div>
                            </div>
                            <div class="mb-3">
                                <div class="form-group">
                                    <label class="form-label">Citizens ID</label>
                                    <input name="citizens_id" type="text" class="form-control"
                                           placeholder="Citizens ID...">
                                </div>
                            </div>
                            <div class="mb-3">
                                <div class="form-group">
                                    <label class="form-label">Address</label>
                                    <input name="address" type="text" class="form-control"
                                           placeholder="Address...">
                                </div>
                            </div>
                                <label class="form-label">Date of Birth</label>
                                <input class="form-control" type="date" name="dob" placeholder="Date of Birthday...">
                            <div class="mb-3">
                                <label class="form-label">Role</label>
                                <div class="form">
                                    @foreach($roles as $role)
                                        <div class="row">
                                            <div class="form-check">
                                                <input class="form-check-input" type="checkbox"
                                                       name="role" value="{{ $role->id }}">
                                                <label class="form-check-label" for="flexCheckDefault">
                                                    {{ $role->name }}
                                                </label>
                                            </div>
                                        </div>
                                    @endforeach
                                </div>
                            </div>
                            <button type="submit" class="btn btn-success" >Submit</button>
                        </form>
                    </div>
                </div>
            </div>
        </main>
    </div>
    <script type="text/javascript">
        $('.date').datepicker({
            format: 'dd-mm-yyyy'
        });
    </script>
@endsection

resources/views/admin/users/edit.blade.php
@extends('admin.layouts.app')

@section('title')
    <title>Update User</title>
@endsection

@section('content')
    <div id="layoutSidenav_content">
        <main>
            <div class="container-fluid px-4">
                <h1 class="mt-4">Update User</h1>
                <ol class="breadcrumb mb-4">
                    <a class="breadcrumb-item active" href="{{ url()->previous() }}">Back>></a>
                </ol>
                <div class="container">
                    <div class="row justify-content-center">
                        <form action="{{route('users.update', $user->id)}}" method="POST" enctype="multipart/form-data">
                            @csrf
                            @method('PUT')
                            <div class="mb-3">
                                <div class="form-group">
                                    <label class="form-label">User Code</label>
                                    <input name="user_code" type="text" class="form-control"
                                           placeholder="User Code..." value="{{$user->user_code}}">
                                </div>
                            </div>
                            <div class="mb-3">
                                <div class="form-group">
                                    <label class="form-label">Full Name</label>
                                    <input name="full_name" type="text" class="form-control"
                                           placeholder="Full Name..." value="{{$user->full_name}}">
                                </div>
                            </div>
                            <div class="mb-3">
                                <div class="form-group">
                                    <label class="form-label">Email</label>
                                    <input name="email" type="text" class="form-control"
                                           placeholder="Email..." value="{{$user->email}}">
                                </div>
                            </div>
                            <div class="mb-3">
                                <div class="form-group">
                                    <label class="form-label">Phone</label>
                                    <input name="phone" type="text" class="form-control"
                                           placeholder="Phone..." value="{{$user->phone}}">
                                </div>
                            </div>
                            <div class="mb-3">
                                <div class="form-group">
                                    <label class="form-label">Citizens ID</label>
                                    <input name="citizens_id" type="text" class="form-control"
                                           placeholder="Citizens ID..." value="{{$user->citizens_id}}">
                                </div>
                            </div>
                            <div class="mb-3">
                                <div class="form-group">
                                    <label class="form-label">Address</label>
                                    <input name="address" type="text" class="form-control"
                                           placeholder="Address..." value="{{$user->address}}">
                                </div>
                            </div>
                            <div class="mb-3">
                                <div class="form-group">
                                    <label class="form-label">Date of Birthday</label>
                                    <input name="dob" type="date" class="form-control"
                                           placeholder="Date of Birthday..." value="{{$user->dob}}">
                                </div>
                            </div>
                            <div class="form">
                                @foreach($roles as $role)
                                    <div class="row">
                                        <div class="form-check">
                                            <input class="form-check-input" type="checkbox"
                                                   name="role" value="{{ $role->id }}">
                                            <label class="form-check-label" for="flexCheckDefault">
                                                {{ $role->name }}
                                            </label>
                                        </div>
                                    </div>
                                @endforeach
                            </div>
                            <button type="submit" class="btn btn-success" >Update User</button>
                        </form>
                    </div>
                </div>
            </div>
        </main>
    </div>
@endsection

resources/views/admin/users/index.blade.php
@extends('admin.layouts.app')

@section('title')
    <title>User Management</title>
@endsection

@section('content')
    <div id="layoutSidenav_content">
        <main>
            <h1></h1>
            <div class="container-fluid px-4">
                <h1 class="mt-4">User Management</h1>
                <ol class="breadcrumb mb-4">
                    <a class="breadcrumb-item active" href="{{ route('home') }}">HomePage</a>
                </ol>
                <div class="row mt-5">
                    <form action=" {{ route('users.search') }}" class="input-group col-9" method="GET" style="margin-left: 9%">
                        <input type="search" class="form-control rounded col-5" placeholder="Search" name="key" />
                        <button type="submit" class="btn btn-outline-primary ml-2 col-1">search</button>
                    </form>
                    <div class="col-2" style="margin-left: -1%">
                        <a href="{{ route('users.create') }}" class="btn btn-success col-5">
                            <i class="fas fa-plus-circle"></i>&nbsp;Create
                        </a>
                    </div>
                </div>
            </div>
            <div class="d-flex justify-content-center">
                <table class="table table-bordered mt-5" style="width: 90% !important;">
                <thead>
                <tr align="center">
                    <th scope="col">Order</th>
                    <th scope="col">Full Name</th>
                    <th scope="col">Email</th>
                    <th scope="col">Phone</th>
                    <th scope="col">Citizens ID</th>
                    <th scope="col">Address</th>
                    <th scope="col">Date of Birth</th>
                    <th scope="col">Role</th>
                    <th scope="col">Action</th>
                </tr>
                </thead>
                <tbody align="center">
                @foreach($users as $key => $user)
                    <tr>
                        <td scope="row">{{$key+1}}</td>
                        <td scope="row">{{$user->full_name}}</td>
                        <td scope="row">{{$user->email}}</td>
                        <td scope="row">0{{$user->phone}}</td>
                        <td scope="row">{{$user->citizens_id}}</td>
                        <td scope="row">{{$user->address}}</td>
                        <td scope="row">{{\Carbon\Carbon::parse($user->dob)->format('d-m-Y')}}</td>
                        @foreach($user->roles as $role)
                            <td scope="row">{{$role->name}}</td>
                        @endforeach
                        <td>
                            <a href="{{route('users.show', $user->id)}}" class="btn btn-primary"><i
                                    class="far fa-eye"></i></a>
                            <a href="{{route('users.edit', $user->id)}}" class="btn btn-success"><i
                                    class="far fa-edit"></i></a>
                            <button type="submit" class="btn btn-danger btn-delete" onclick="deleteUser({{$user->id}})"><i
                                    class="fas fa-trash-alt"></i></button>
                            <form action="{{route('users.destroy', $user->id)}}" id="form-{{$user->id}}" method="POST">
                                @method('DELETE')
                                @csrf

                            </form>
                        </td>
                    </tr>
                @endforeach
                </tbody>
            </table>
            </div>
            <div class="container-fluid d-flex" style="justify-content: flex-end; margin-left: -4%;">
                {{$users->links()}}
            </div>
@endsection
@push('scripts')
    <script>
        function deleteUser(id)
        {
            Swal.fire({
                title: 'Are you sure?',
                text: "You won't be able to revert this!",
                icon: 'warning',
                showCancelButton: true,
                confirmButtonColor: '#3085d6',
                cancelButtonColor: '#d33',
                confirmButtonText: 'Yes, delete it!'
            }).then((result) => {
                if (result.isConfirmed) {
                    event.preventDefault();
                    document.getElementById('form-' + id).submit();
                    Swal.fire(
                        'Deleted!',
                        'Your file has been deleted.',
                        'success'
                    )
                }
            })
        }
    </script>
@endpush

resources/views/admin/users/show.blade.php
@extends('admin.layouts.app')

@section('title')
    <title>User Detail</title>
@endsection

@section('content')
    <div id="layoutSidenav_content">
        <main>
            <div class="container-fluid px-4">
                <h1 class="mt-4">User Detail</h1>
                <ol class="breadcrumb mb-4">
                    <a class="breadcrumb-item active" href="{{ url()->previous() }}">Back>></a>
                </ol>
            </div>
            <table class="table table-striped">
                <thead>
                <tr align="center">
                    <th scope="col">ID</th>
                    <th scope="col">User Code</th>
                    <th scope="col">Full Name</th>
                    <th scope="col">Email</th>
                    <th scope="col">Phone</th>
                    <th scope="col">Citizens ID</th>
                    <th scope="col">Address</th>
                    <th scope="col">Date of Birth</th>
                </tr>
                </thead>
                <tbody align="center">
                    <tr>
                        <td scope="row">{{$user->id}}</td>
                        <td scope="row">{{$user->user_code}}</td>
                        <td scope="row">{{$user->full_name}}</td>
                        <td scope="row">{{$user->email}}</td>
                        <td scope="row">{{$user->phone}}</td>
                        <td scope="row">{{$user->citizens_id}}</td>
                        <td scope="row">{{$user->address}}</td>
                        <td scope="row">{{$user->dob}}</td>
                    </tr>
                </tbody>
            </table>
            <div class="container-fluid">
            </div>
@endsection